config/routes.rb
Rails.application.routes.draw do


  get 'logout' => 'sessions#logout'
  get 'login' => 'sessions#login'
  post 'login_process' => 'sessions#login_process'
  get 'welcome_user' => 'sessions#welcome_user'
  get 'student_rank' => 'students#student_rank'

  
  resources :student_marks
  resources :subjects
  resources :students
  resources :users
  resources :roles

  root 'sessions#login'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/student_mark.rb
class StudentMark < ApplicationRecord
  belongs_to :student
  belongs_to :subject
  belongs_to :user

  # validates :student_id, uniqueness: true
  # validates :subject_id, uniqueness: true
  # validates :user_id, uniqueness: true

  validates_uniqueness_of :subject_id, scope: %i[user_id student_id]

end

app/controllers/student_marks_controller.rb
class StudentMarksController < ApplicationController
  before_action :set_student_mark, only: [:show, :edit, :update, :destroy]

  # GET /student_marks
  # GET /student_marks.json
  def index
    # @student_marks = StudentMark.all
    if current_user.role.role_name == "Admin"
      @student_marks = StudentMark.all
    else
      @student_marks = StudentMark.where(user_id: current_user.id)
    end
  end

  # GET /student_marks/1
  # GET /student_marks/1.json
  def show
  end

  # GET /student_marks/new
  def new
    @student_mark = StudentMark.new
  end

  # GET /student_marks/1/edit
  def edit
  end

  # POST /student_marks
  # POST /student_marks.json
  def create
    @student_mark = StudentMark.new(student_mark_params)

    respond_to do |format|
      if @student_mark.save
        RankCalculation.rank_calculate(@student_mark.student_id)
        format.html { redirect_to student_marks_url, notice: 'Student mark was successfully created.' }
        format.json { render :show, status: :created, location: @student_mark }
      else
        format.html { render :new }
        format.json { render json: @student_mark.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /student_marks/1
  # PATCH/PUT /student_marks/1.json
  def update
    respond_to do |format|
      if @student_mark.update(student_mark_params)
        RankCalculation.rank_calculate(@student_mark.student_id)
        format.html { redirect_to student_marks_url, notice: 'Student mark was successfully updated.' }
        format.json { render :show, status: :ok, location: @student_mark }
      else
        format.html { render :edit }
        format.json { render json: @student_mark.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /student_marks/1
  # DELETE /student_marks/1.json
  def destroy
    @student_mark.destroy
    respond_to do |format|
      format.html { redirect_to student_marks_url, notice: 'Student mark was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_student_mark
      @student_mark = StudentMark.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def student_mark_params
      params.require(:student_mark).permit(:student_id, :subject_id, :user_id, :mark)
    end
end

app/helpers/student_marks_helper.rb
module StudentMarksHelper
end

app/views/student_marks/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: student_mark, local: true) do |form| %>
  <% if student_mark.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(student_mark.errors.count, "error") %> prohibited this student_mark from being saved:</h2>

      <ul>
        <% student_mark.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="container">
    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :student, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%= form.collection_select(:student_id,Student.all, :id,:stud_name, {prompt: true}, {id: :student_dropdown}) %>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :subject, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%#= form.collection_select(:subject_id,Subject.all, :id,:sub_name, {prompt: true}, {id: :subject_dropdown}) %>
          <%= form.text_field :sub_name, value: Subject.find_by(user_id: current_user.id).sub_name, :readonly => true %>
          <%= form.hidden_field :subject_id, value: Subject.find_by(user_id: current_user.id).id%>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :mark, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%= form.number_field :mark, step: :any, id: :student_mark, class: "form-control", required: true %>
        </div>
      </div>
    </div>

    <%= form.hidden_field :user_id, value: current_user.id  %>

    <div class="actions">
      <%= form.submit "Submit", class:"btn btn-primary float-right" %>
      <%= link_to "Cancel", student_marks_path, class: "btn btn-warning float-right mr-3" %>
    </div>
  </div>

<% end %>

app/views/student_marks/edit.html.erb
<h1>Editing Student Mark</h1>

<%= render 'form', student_mark: @student_mark %>

<%#= link_to 'Show', @user, class: "btn btn-info float-right mr-3" %> 

app/views/student_marks/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
  <div class="col-md-5 align-self-center">
    <h3 class="text-primary">Student Marks</h3>
  </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <% if current_user.role.role_name != "Admin" %>
        <div class="col-md-1 pull-right">
          <%= link_to 'New', new_student_mark_path , class: "btn btn-info float-right mr-3" %> 
        </div>
      <% end %>
      <div class="col-md-1 pull-right">
        <%= link_to 'Back', welcome_user_path , class: "btn btn-warning float-right mr-3" %>
      </div>
    </div>
  </div>
</div>
<br>

<table id="student_mark_list">
  <thead>
    <tr>
      <th>Student</th>
      <th>Subject</th>
      <th>Teacher</th>
      <th>Mark</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @student_marks.each do |student_mark| %>
      <tr>
        <td><%= student_mark.student.stud_name %></td>
        <td><%= student_mark.subject.sub_name %></td>
        <td><%= student_mark.user.user_name %></td>
        <td><%= student_mark.mark %></td>
        <% if current_user.role.role_name != "Admin" %>
          <!-- <td><%#= link_to 'Show', student_mark %></td> -->
          <td><%= link_to "<i class='fa fa-eye' title='Student Mark'></i>".html_safe, student_mark%>
          <td><%= link_to "<i class='fa fa-pencil' title='Edit Student Mark'></i>".html_safe, edit_student_mark_path(student_mark) %></td>
          <!-- <td><%#= link_to 'Destroy', student_mark, method: :delete, data: { confirm: 'Are you sure?' } %></td> -->
        <% end %>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<script type="text/javascript">
  $(document).ready(function(){
    $('#student_mark_list').dataTable();
  });
</script>

app/views/student_marks/new.html.erb
<h1>New Student Mark</h1>

<%= render 'form', student_mark: @student_mark %>

app/views/student_marks/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Student:</strong>
  <%= @student_mark.student.stud_name %>
</p>

<p>
  <strong>Subject:</strong>
  <%= @student_mark.subject.sub_name %>
</p>

<p>
  <strong>User:</strong>
  <%= @student_mark.user.user_name %>
</p>

<p>
  <strong>Mark:</strong>
  <%= @student_mark.mark %>
</p>

<%= link_to 'Edit', edit_student_mark_path(@student_mark), class: "btn btn-danger float-right mr-3" %> 
<%= link_to "Back", student_marks_path, class: "btn btn-warning float-right mr-3" %>